# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class EndpointsRequesttrackerBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'custom_properties': 'CmxapiresourcestmcendpointsrequesttrackerCustomProperties',
        'endpoint_properties': 'CmxapiresourcestmcendpointsrequesttrackerEndpointProperties',
        'endpoint_type': 'str',
        'name': 'str',
        'request_type': 'str',
        'resource_link': 'str',
        'resource_reference': 'str',
        'task_link': 'str',
        'task_reference': 'str'
    }

    attribute_map = {
        'custom_properties': 'customProperties',
        'endpoint_properties': 'endpointProperties',
        'endpoint_type': 'endpointType',
        'name': 'name',
        'request_type': 'requestType',
        'resource_link': 'resourceLink',
        'resource_reference': 'resourceReference',
        'task_link': 'taskLink',
        'task_reference': 'taskReference'
    }

    def __init__(self, custom_properties=None, endpoint_properties=None, endpoint_type=None, name=None, request_type=None, resource_link=None, resource_reference=None, task_link=None, task_reference=None):  # noqa: E501
        """EndpointsRequesttrackerBody - a model defined in Swagger"""  # noqa: E501
        self._custom_properties = None
        self._endpoint_properties = None
        self._endpoint_type = None
        self._name = None
        self._request_type = None
        self._resource_link = None
        self._resource_reference = None
        self._task_link = None
        self._task_reference = None
        self.discriminator = None
        if custom_properties is not None:
            self.custom_properties = custom_properties
        if endpoint_properties is not None:
            self.endpoint_properties = endpoint_properties
        if endpoint_type is not None:
            self.endpoint_type = endpoint_type
        if name is not None:
            self.name = name
        if request_type is not None:
            self.request_type = request_type
        if resource_link is not None:
            self.resource_link = resource_link
        if resource_reference is not None:
            self.resource_reference = resource_reference
        if task_link is not None:
            self.task_link = task_link
        if task_reference is not None:
            self.task_reference = task_reference

    @property
    def custom_properties(self):
        """Gets the custom_properties of this EndpointsRequesttrackerBody.  # noqa: E501


        :return: The custom_properties of this EndpointsRequesttrackerBody.  # noqa: E501
        :rtype: CmxapiresourcestmcendpointsrequesttrackerCustomProperties
        """
        return self._custom_properties

    @custom_properties.setter
    def custom_properties(self, custom_properties):
        """Sets the custom_properties of this EndpointsRequesttrackerBody.


        :param custom_properties: The custom_properties of this EndpointsRequesttrackerBody.  # noqa: E501
        :type: CmxapiresourcestmcendpointsrequesttrackerCustomProperties
        """

        self._custom_properties = custom_properties

    @property
    def endpoint_properties(self):
        """Gets the endpoint_properties of this EndpointsRequesttrackerBody.  # noqa: E501


        :return: The endpoint_properties of this EndpointsRequesttrackerBody.  # noqa: E501
        :rtype: CmxapiresourcestmcendpointsrequesttrackerEndpointProperties
        """
        return self._endpoint_properties

    @endpoint_properties.setter
    def endpoint_properties(self, endpoint_properties):
        """Sets the endpoint_properties of this EndpointsRequesttrackerBody.


        :param endpoint_properties: The endpoint_properties of this EndpointsRequesttrackerBody.  # noqa: E501
        :type: CmxapiresourcestmcendpointsrequesttrackerEndpointProperties
        """

        self._endpoint_properties = endpoint_properties

    @property
    def endpoint_type(self):
        """Gets the endpoint_type of this EndpointsRequesttrackerBody.  # noqa: E501


        :return: The endpoint_type of this EndpointsRequesttrackerBody.  # noqa: E501
        :rtype: str
        """
        return self._endpoint_type

    @endpoint_type.setter
    def endpoint_type(self, endpoint_type):
        """Sets the endpoint_type of this EndpointsRequesttrackerBody.


        :param endpoint_type: The endpoint_type of this EndpointsRequesttrackerBody.  # noqa: E501
        :type: str
        """

        self._endpoint_type = endpoint_type

    @property
    def name(self):
        """Gets the name of this EndpointsRequesttrackerBody.  # noqa: E501


        :return: The name of this EndpointsRequesttrackerBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this EndpointsRequesttrackerBody.


        :param name: The name of this EndpointsRequesttrackerBody.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def request_type(self):
        """Gets the request_type of this EndpointsRequesttrackerBody.  # noqa: E501


        :return: The request_type of this EndpointsRequesttrackerBody.  # noqa: E501
        :rtype: str
        """
        return self._request_type

    @request_type.setter
    def request_type(self, request_type):
        """Sets the request_type of this EndpointsRequesttrackerBody.


        :param request_type: The request_type of this EndpointsRequesttrackerBody.  # noqa: E501
        :type: str
        """

        self._request_type = request_type

    @property
    def resource_link(self):
        """Gets the resource_link of this EndpointsRequesttrackerBody.  # noqa: E501


        :return: The resource_link of this EndpointsRequesttrackerBody.  # noqa: E501
        :rtype: str
        """
        return self._resource_link

    @resource_link.setter
    def resource_link(self, resource_link):
        """Sets the resource_link of this EndpointsRequesttrackerBody.


        :param resource_link: The resource_link of this EndpointsRequesttrackerBody.  # noqa: E501
        :type: str
        """

        self._resource_link = resource_link

    @property
    def resource_reference(self):
        """Gets the resource_reference of this EndpointsRequesttrackerBody.  # noqa: E501


        :return: The resource_reference of this EndpointsRequesttrackerBody.  # noqa: E501
        :rtype: str
        """
        return self._resource_reference

    @resource_reference.setter
    def resource_reference(self, resource_reference):
        """Sets the resource_reference of this EndpointsRequesttrackerBody.


        :param resource_reference: The resource_reference of this EndpointsRequesttrackerBody.  # noqa: E501
        :type: str
        """

        self._resource_reference = resource_reference

    @property
    def task_link(self):
        """Gets the task_link of this EndpointsRequesttrackerBody.  # noqa: E501


        :return: The task_link of this EndpointsRequesttrackerBody.  # noqa: E501
        :rtype: str
        """
        return self._task_link

    @task_link.setter
    def task_link(self, task_link):
        """Sets the task_link of this EndpointsRequesttrackerBody.


        :param task_link: The task_link of this EndpointsRequesttrackerBody.  # noqa: E501
        :type: str
        """

        self._task_link = task_link

    @property
    def task_reference(self):
        """Gets the task_reference of this EndpointsRequesttrackerBody.  # noqa: E501


        :return: The task_reference of this EndpointsRequesttrackerBody.  # noqa: E501
        :rtype: str
        """
        return self._task_reference

    @task_reference.setter
    def task_reference(self, task_reference):
        """Sets the task_reference of this EndpointsRequesttrackerBody.


        :param task_reference: The task_reference of this EndpointsRequesttrackerBody.  # noqa: E501
        :type: str
        """

        self._task_reference = task_reference

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EndpointsRequesttrackerBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EndpointsRequesttrackerBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
